<?php

namespace FiloBlu\ScratchAndWin\Block;

use Magento\Framework\DataObject\IdentityInterface;
use Magento\Framework\View\Element\Template;

class ScratchAndWin extends Template implements IdentityInterface {

    protected $_scratchAndWin;
    
    public function __construct(
        \FiloBlu\ScratchAndWin\Model\ScratchAndWinFactory $scratchAndWin,         
        \Magento\Framework\View\Element\Template\Context $context, 
        array $data = []
    ) {
        $this->_scratchAndWin = $scratchAndWin;

        parent::__construct($context, $data);
    }

    public function getScratchAndWin() {

        if (!$this->getScratchAndWinEntity() && $this->getCode()) {
            $this->setScratchAndWinEntity($this->_scratchAndWin->create()->getScratchAndWinByCode($this->getCode()));
        }
        return $this->getScratchAndWinEntity();
    }
    
    public function getScratchAndWinDetails() {                
        return $this->_scratchAndWin->create()->getScratchAndWinDetails($this->getScratchAndWin()->getId());
    }

    protected function _toHtml() {

        $scratchandwin = $this->getScratchAndWin();
        
        if (!$scratchandwin) {
            return "";
        }

        if($scratchandwin->getCode()) {
            $this->setTemplate('FiloBlu_ScratchAndWin::scratchandwin/scratchandwin_' . $scratchandwin->getCode() . '.phtml');
        }
        
        if (!$this->getTemplateFile()) {
            $this->setTemplate('FiloBlu_ScratchAndWin::scratchandwin/scratchandwin.phtml');
        }

        return parent::_toHtml();
    }

    public function getIdentities()
    {
        if ($this->getScratchAndWin() && $this->getScratchAndWin()->getId()) {            
            return [\FiloBlu\ScratchAndWin\Model\ScratchAndWin::CACHE_TAG . '_' . $this->getScratchAndWin()->getId()];
        } else {
            return [];
        }

    }

    public function getCacheKeyInfo()
    {
        if ($this->getScratchAndWin() && $this->getScratchAndWin()->getId()) {
            return [
                \FiloBlu\ScratchAndWin\Model\ScratchAndWin::CACHE_TAG,
                'scratchandwin_' . $this->getScratchAndWin()->getId(),
                'store_' . $this->_storeManager->getStore()->getId(),
            ];
        } else {
            return [];
        }
    }

    public function getCacheLifetime()
    {
        return 86400;
    }

}
