<?php

namespace FiloBlu\ScratchAndWin\Model;

class ScratchAndWinDetailsTranslations extends \Magento\Framework\Model\AbstractModel {

    const CACHE_TAG = 'fb_scratchandwin';

    protected $_cacheTag = self::CACHE_TAG;

    protected $_scratchAndWinDetails;

    public function __construct(
            \Magento\Framework\Model\Context $context,
            \Magento\Framework\Registry $registry,
            \FiloBlu\ScratchAndWin\Model\ScratchAndWinDetailsFactory $scratchAndWinDetails,         
            \Magento\Framework\Model\ResourceModel\AbstractResource $resource = null,
            \Magento\Framework\Data\Collection\AbstractDb $resourceCollection = null,
            array $data = []
    ) {
        $this->_scratchAndWinDetails = $scratchAndWinDetails;

        parent::__construct($context, $registry, $resource, $resourceCollection, $data);
    }

    /**
     * Initialize resource model
     *
     * @return void
     */
    protected function _construct() {
        $this->_init('FiloBlu\ScratchAndWin\Model\ResourceModel\ScratchAndWinDetailsTranslations');
    }

    public function loadByParentAndStoreId($parentId,$storeId)
    {
        $result = $this->getResource()->loadByParentAndStoreId($parentId,$storeId);

        if ($result) {
            $this->addData($result);            
        }

        $this->_cacheTag = $this->_scratchAndWinDetails->create()->getScratchAndWinIdRelations($parentId);
        
        return $this;
    }

}
